/*************************************************************/
/* Copyright (C) 2015 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: dsrc_reg_d */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.Libitsmapspat_asn1 */
/* Created: Mon Feb  9 16:50:07 2015 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1
 * -nolistingfile -nomodlistingfile -constraints -nouserconstraints -valuerefs
 * -debug -nopedantic -noinformatorymessages -uper -root -keepnames
 * -norelaySafe -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-2015.02.09.16.49.37.896/oss6894826343771225846gen/LibItsMapSpat_asn1.gen
 * asn/ITS-Container.asn asn/REG_D.asn asn/MAP_SPAT_ETSI.asn
 * asn/DSRC_REG_D.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type MovementEvent from ASN1 Module DSRC.
 * @see Sequence
 */

public class MovementEvent extends Sequence {
    
    /**
     * The default constructor.
     */
    public MovementEvent()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public MovementEvent(MovementPhaseState eventState, 
		    TimeChangeDetails timing, AdvisorySpeedList speeds, 
		    RegionalMovementEvent regional)
    {
	setEventState(eventState);
	setTiming(timing);
	setSpeeds(speeds);
	setRegional(regional);
    }
    
    /**
     * Construct with required components.
     */
    public MovementEvent(MovementPhaseState eventState)
    {
	setEventState(eventState);
    }
    
    public void initComponents()
    {
	mComponents[0] = MovementPhaseState.unavailable;
	mComponents[1] = new TimeChangeDetails();
	mComponents[2] = new AdvisorySpeedList();
	mComponents[3] = new RegionalMovementEvent();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[4];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return MovementPhaseState.unavailable;
	    case 1:
		return new TimeChangeDetails();
	    case 2:
		return new AdvisorySpeedList();
	    case 3:
		return new RegionalMovementEvent();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "eventState"
    public MovementPhaseState getEventState()
    {
	return (MovementPhaseState)mComponents[0];
    }
    
    public void setEventState(MovementPhaseState eventState)
    {
	mComponents[0] = eventState;
    }
    
    
    // Methods for field "timing"
    public TimeChangeDetails getTiming()
    {
	return (TimeChangeDetails)mComponents[1];
    }
    
    public void setTiming(TimeChangeDetails timing)
    {
	mComponents[1] = timing;
    }
    
    public boolean hasTiming()
    {
	return componentIsPresent(1);
    }
    
    public void deleteTiming()
    {
	setComponentAbsent(1);
    }
    
    
    // Methods for field "speeds"
    public AdvisorySpeedList getSpeeds()
    {
	return (AdvisorySpeedList)mComponents[2];
    }
    
    public void setSpeeds(AdvisorySpeedList speeds)
    {
	mComponents[2] = speeds;
    }
    
    public boolean hasSpeeds()
    {
	return componentIsPresent(2);
    }
    
    public void deleteSpeeds()
    {
	setComponentAbsent(2);
    }
    
    
    // Methods for field "regional"
    public RegionalMovementEvent getRegional()
    {
	return (RegionalMovementEvent)mComponents[3];
    }
    
    public void setRegional(RegionalMovementEvent regional)
    {
	mComponents[3] = regional;
    }
    
    public boolean hasRegional()
    {
	return componentIsPresent(3);
    }
    
    public void deleteRegional()
    {
	setComponentAbsent(3);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
	    "MovementEvent"
	),
	new QName (
	    "DSRC",
	    "MovementEvent"
	),
	12318,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"MovementPhaseState"
			    ),
			    new QName (
				"DSRC",
				"MovementPhaseState"
			    ),
			    12314,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"unavailable",
					0
				    ),
				    new MemberListElement (
					"dark",
					1
				    ),
				    new MemberListElement (
					"stop-Then-Proceed",
					2
				    ),
				    new MemberListElement (
					"stop-And-Remain",
					3
				    ),
				    new MemberListElement (
					"pre-Movement",
					4
				    ),
				    new MemberListElement (
					"permissive-Movement-Allowed",
					5
				    ),
				    new MemberListElement (
					"protected-Movement-Allowed",
					6
				    ),
				    new MemberListElement (
					"permissive-clearance",
					7
				    ),
				    new MemberListElement (
					"protected-clearance",
					8
				    ),
				    new MemberListElement (
					"caution-Conflicting-Traffic",
					9
				    )
				}
			    ),
			    0,
			    MovementPhaseState.unavailable
			)
		    ),
		    "eventState",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"TimeChangeDetails"
			    ),
			    new QName (
				"DSRC",
				"TimeChangeDetails"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				    "TimeChangeDetails"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				    "TimeChangeDetails"
				)
			    ),
			    0
			)
		    ),
		    "timing",
		    1,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new ContainerInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"AdvisorySpeedList"
			    ),
			    new QName (
				"DSRC",
				"AdvisorySpeedList"
			    ),
			    12314,
			    new SizeConstraint (
				new ValueRangeConstraint (
				    new AbstractBounds(
					new com.oss.asn1.INTEGER(1), 
					new com.oss.asn1.INTEGER(16),
					0
				    )
				)
			    ),
			    new Bounds (
				new java.lang.Long(1),
				new java.lang.Long(16)
			    ),
			    new TypeInfoRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				    "AdvisorySpeed"
				)
			    )
			)
		    ),
		    "speeds",
		    2,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"RegionalMovementEvent"
			    ),
			    new QName (
				"DSRC",
				"RegionalMovementEvent"
			    ),
			    12318,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				    "RegionalMovementEvent"
				)
			    ),
			    0,
			    null,
			    0
			)
		    ),
		    "regional",
		    3,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1),
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' MovementEvent object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' MovementEvent object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for MovementEvent
